#include <Servo.h>

Servo servo_a;
Servo servo_b;

int posS = 0;//переменная для значений угла поворота сервопривода
int pos_a = 0;//переменная для вычисленных значений угла по обратной связи для сервы _a
int pos_b = 0;//переменная для вычисленных значений угла по обратной связи для сервы _b
int tabl_a[20];// массив хранения запомненных углов для сервы _a
int tabl_b[20];// массив хранения запомненных углов для сервы _b
int n=500;//длительность общая шага-цикла в мс
int i=0;//счётчик элементов массивов
boolean fl_A=false;//флаг состояний
long Ya=0;//переменная хранения моментов времени
long Yb=0;//переменная хранения моментов времени
int da;int db;// переменные приращения углов
int ga;int gb;// переменные длительностей между переключениями серв

void setup() {
   pinMode(13,OUTPUT);//вывод канала нагрузки
   digitalWrite(13, LOW);
   servo_a.attach(8); servo_a.write(90);delay(500); servo_a.detach();//начальные установки
   servo_b.attach(9); servo_b.write(90);delay(500); servo_b.detach();//начальные установки
   pinMode(10,INPUT);//вывод кнопки записи-воспроизведения движений серв 
} 
void loop() {
 if(digitalRead(10)==LOW) {delay(300);//временная пауза для преодоления дребезга контактов кнопки
 if(digitalRead(10)==HIGH)//если происходит краткое нажатие кнопки
  {tabl_a[i]=(analogRead(A0) - 75) / 3; tabl_b[i]=(analogRead(A1) - 79) / 3; i++;if(i>20){i=0;}//запись выставленных значений углов в массивы 
  digitalWrite(13, HIGH);delay(300);digitalWrite(13, LOW);}//кратко мигаем светодиодом -запись прошла
  if(digitalRead(10)==LOW)//если происходит долгое нажатие кнопки
  { digitalWrite(13, HIGH); servo_a.attach(8); servo_a.write((analogRead(A0) - 75) / 3); servo_b.attach(9); servo_b.write((analogRead(A1) - 79) / 3);
  ispol_();}//исполнение записанного в массивы
 } 
}
void ispol_()
{
  while(true)//запускается бесконечный цикл ходьбы
  {
   for (i=0;i<20;i++)//проверяем все элементы массивов
   {
     if(tabl_a[i]!=0||tabl_b[i]!=0)//если хоть один элемент не 0
     {
      ////////////////
      if(tabl_a[i]-servo_a.read()>0){da=1;}//определяем есть ли приращение и его знак
      if(tabl_a[i]-servo_a.read()<0){da=-1;}
      if(tabl_b[i]-servo_b.read()>0){db=1;}
      if(tabl_b[i]-servo_b.read()<0){db=-1;}
      if(tabl_a[i]-servo_a.read()==0){da=0;}
      if(tabl_b[i]-servo_b.read()==0){db=0;}
      if(da!=0){ga=n/abs(tabl_a[i]-servo_a.read());}//определяем временную паузу между приращениями шага
      if(da==0){ga=0;}
      if(db!=0){gb=n/abs(tabl_b[i]-servo_b.read());}
      if(db==0){gb=0;}
      ////////////////
      while(tabl_a[i]!=servo_a.read()||tabl_b[i]!=servo_b.read())//пока хоть один элемент не совпадает с выставленным...
      {
       if(millis()-Ya>ga&&tabl_a[i]!=servo_a.read()){Ya=millis(); servo_a.write(servo_a.read()+da);}
       if(millis()-Yb>gb&&tabl_b[i]!=servo_b.read()){Yb=millis(); servo_b.write(servo_b.read()+db);}
      }
     }
   }
  }
}
/////////////////////////////////////////////////////////////
